GLOBAL          _LGDT, _SGDT, _LIDT, _SIDT, _LTR, _STR
GLOBAL          _LCR0, _SCR0, _LCR3, _SCR3, _SCR2, _CLTS, _INVLPG
GLOBAL          _RESET

%define PARAM_1 ebp+8+4*0
%define PARAM_2 ebp+8+4*1
%define PARAM_3 ebp+8+4*2
%define PARAM_4 ebp+8+4*3

[SECTION .text]
[BITS 32]

_LGDT:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        lgdt    [eax]
        pop     ebp
        ret

_SGDT:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        sgdt    [eax]
        pop     ebp
        ret

_LIDT:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        lidt    [eax]
        pop     ebp
        ret

_SIDT:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        sidt    [eax]
        pop     ebp
        ret

_LTR:
        push    ebp
        mov     ebp, esp
        ltr     [PARAM_1]
        pop     ebp
        ret

_STR:
        xor     eax, eax
        str     ax
        ret

_LCR0:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        mov     cr0, eax
        jmp     short $+2
        pop     ebp
        ret

_SCR0:
        mov     eax, cr0
        ret

_LCR3:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        mov     cr3, eax
        pop     ebp
        ret

_SCR3:
        mov     eax, cr3
        ret

_SCR2:
        mov     eax, cr2
        ret

_CLTS:
        clts
        ret

_INVLPG:
        push    ebp
        mov     ebp, esp
        mov     eax, [PARAM_1]
        invlpg  [eax]
        pop     ebp
        ret

_RESET:
        cli
        push    dword 0
        push    dword 0
        lidt    [esp]                   ; gdtr.limit=0
        int     0                       ; triple fault and reset
