#ifndef _vesa_
#define _vesa_

#define BLACK           0
#define BLUE            1
#define GREEN           2
#define CYAN            3
#define RED             4
#define MAGENTA         5
#define BROWN           6
#define LIGHTGRAY       7
#define DARKGRAY        8
#define LIGHTBLUE       9
#define LIGHTGREEN      10
#define LIGHTCYAN       11
#define LIGHTRED        12
#define LIGHTMAGENTA    13
#define YELLOW          14
#define WHITE           15

#pragma pack (push, 1)

typedef struct {
  unsigned long         ID;             // 0x41534556 = "VESA"
  unsigned short        Ver;
  unsigned char         *OEMName;
  unsigned long         Capatibs;
  unsigned short        *ModeList;
  unsigned short        TotalMemory;
  unsigned char         Res[492];
} VESA_INFO;

typedef struct {
  unsigned short        Attrs;
  unsigned char         WinAAttrs,
                        WinBAttrs;
  unsigned short        WinGranul,
                        WinSize,
                        WinASeg,
                        WinBSeg;
  void                  *PWinPosFunc;
  unsigned short        BytesPerScanLine,
                        Width,
                        Height;
  unsigned char         CharWidth,
                        CharHeight,
                        Planes,
                        BitsPerPixel,
                        Banks,
                        MemoryModel,
                        BankSize;
  unsigned char         Res[227];
} VESA_MODE_INFO;

#pragma pack (pop)

#endif
